GMT_map <-
function(display,driver="PS",widthcm=15,scale=0,scaleZ="",legend="",rangeZ="", graph=T,grid="", anots="", gmtset="", gmtsetleg="", scalepos="", legendpos="", scaleoption="", decscale=0, scaletype="c", ori="a", createdisp=T, dxcm="2.5", dycm="2.5", output="outmap", scaleunit="",scalevar="",scaleinter="",textfile="",textcolor="",points,paper="a4",coords=0){

# parameter translation
        system("rm .gmtdefaults4")
        visualizar=graph
        malla=grid
        anchocm=widthcm
        escala=scale
        escalaZ=scaleZ
        rango=rangeZ
        leyenda=legend
        salida=output
        if (length(legendpos)==1){legendparam=""} else{legendparam=paste(legendpos[1],legendpos[2],legendpos[3],legendpos[4],sep="/")}
        if (length(scalepos)==1){scaleparam=""} else{scaleparam=paste(scalepos[1],scalepos[2],scalepos[3],scalepos[4],sep="/")}

# Geometry	
	dpi=300;i2c=0.39;
 	if(length(coords)==1){GT=gmeta6();e=GT$e;n=GT$n;s=GT$s;w=GT$w} else {w=coords[1];e=coords[2];s=coords[3];n=coords[4]}
        dx=GT$e-GT$w; dy=GT$n-GT$s
        if(escala!=0){anchocm=100*dx/escala}else{escala=100*dx/anchocm}
  	ancho=anchocm*i2c*dpi 
 	alto=ancho*dy/dx
 	altocm=alto/(i2c*dpi)  
	region=paste("-R",w,"/",e,"/",s,"/",n,sep="")
	escalaGMT=paste("-JX",anchocm,"c/",altocm,"c",sep="")

        cat("1:",escala,"\n")

# Orientation
        if(ori=="l") {port=""} 
        if(ori=="p") {port="-P"}
        if(ori!="l" && ori!="p" && ori!="a"){ori="a"}
        if(ori=="a"){if(ancho<alto){port="-P"}else{port=""}}
        if (port=="-P") hpap= papers(paper)[2]
        if (port=="") hpap= papers(paper)[1]

        if(dycm==-1) dycm=hpap-(altocm+0.1)
            
# Grid
        if(malla==""){
            b=(GT$n-GT$s)/5
            bb=c(5,10,50,100,500,1000,5000,10000,50000,100000,500000,1000000,5000000)
            for (i in 1:(length(bb)-1)){
                 if(b>bb[i] && b<bb[i+1]){
                     if(b-bb[i]<bb[i+1]-b){malla=bb[i]}else{malla=bb[i+1]}
                 }
             }
        }
        cat("MALLA:  ",malla,"\n")
        if(anots=="") anots=malla;

# Prepare scale Z
	if (escalaZ!=""){
	        # Range
        	if(rango==""){
                      rango=system(paste("r.univar",escalaZ),intern=T)
   		      minr=strsplit(rango[7]," ");minr=as.numeric(minr[[1]][2])
 		      maxr=strsplit(rango[8]," ");maxr=as.numeric(maxr[[1]][2])
                }
                else{minr=rango[1];maxr=rango[2]}
	        # Crea un fichero cpt a partir del fichero colr de GRASS
                # si el fichero no existe lo creo primero
                if(length(colr_grass(escalaZ))==0){
                    orden=paste("r.colors ",escalaZ," color=rainbow",sep="")
                    system(orden)
                }
                #destripa el fichero colr de GRASS asumiendo que es continuo, es decir V:R:G:B V:R:G:B
                paleta=system(paste("cat",colr_grass(escalaZ)),intern=TRUE)
                cat(paleta,"\n");cat(length(paleta),"\n");
                n1=0
		for (i in 2:length(paleta)){
        	     #paleta[i]=gsub(":"," ",paleta[i])
		     kk=strsplit(paleta[i]," ")[[1]];kk1=strsplit(kk[1],":")[[1]];kk2=strsplit(kk[2],":")[[1]];

                     if(length(kk1)==2){kk1[3]=kk1[4]=kk1[2]}
                     if(length(kk2)==2){kk2[3]=kk2[4]=kk2[2]}

cat(as.numeric(l)," ",maxrminr," ", n1,"\n")

        	     l=kk1[[1]][1];if (as.numeric(l)>minr && n1==0){n1=i}
        	     l=kk2[[1]][1];if (as.numeric(l)<maxr){n2=i}   
                     if(scaletype=="d"){
                           paleta[i]=sprintf("%s %s %s %s %s %s %s %s",kk1[1],kk1[2],kk1[3],kk1[4],kk2[1],kk1[2],kk1[3],kk1[4])
		     }
                     if(scaletype=="c"){
                           paleta[i]=sprintf("%s %s %s %s %s %s %s %s",kk1[1],kk1[2],kk1[3],kk1[4],kk2[1],kk2[2],kk2[3],kk2[4])
		     }
        	     n11=max(2,n1-1);n22=min(length(paleta),n2+1)
                     write(paleta[n11:n22],paste(escalaZ,"cpt",sep="."))
                }
                if(scaleparam==""){scaleparam=paste(anchocm+1,altocm/2,altocm/2,0.5,sep="/")}

                if(scalevar!=""){
                          write(scalevar,file=".scalevar")
                          system("iconv -f utf8 -t latin1 .scalevar>.scalevar2")
                          kk=read.csv(file=".scalevar2",sep=";",header=F)
                          scalevar=kk[1,1]
                }

                scaleoption=paste(scaleoption," -B",scaleinter,":",scalevar,":/:",scaleunit,":",sep="")

        }      

# Create RAS file with the display
        if(createdisp==T){
            if(file.exists(display)){
               orden=paste("convert ",display," ",salida,".ras",sep="")
            }else{
                if(display=="mon"){               # Prepare display if display="mon"
                    kk=system("d.save -o",intern=T)
                    kkk=strsplit(kk[1],split="#")[[1]]
                    display=kkk[1]
                    for (i in 2:length(kk)){
                        kkk=strsplit(kk[i],split="#")[[1]]
                        display=paste(display,";",kkk[1],sep="")
                   }
                }
                if(driver=="PNG"){                               # Create PNG map image, convert it to ras file
                     if(length(selmon())>0){if(selmon()=="PNG"){system("d.mon stop=PNG")}}             
   	             orden=paste("export GRASS_PNG_COMPRESSION=0;export GRASS_WIDTH=",ancho,
                                 ";export GRASS_HEIGHT=",alto,";export GRASS_TRUECOLOR=TRUE;
                                  export GRASS_PNG_COMPRESSION=0;export GRASS_BACKGROUNDCOLOR=255255255;
                                  export GRASS_PNGFILE=",salida,".png;","d.mon PNG;",display,";
                                  d.mon stop=PNG",sep=""
                     )
  	             system(orden)
    	             orden=paste("convert ",salida,".png /tmp/temp.jpg;convert /tmp/temp.jpg ",salida,".ras",sep="")
    	             system(orden)
                }
                if(driver=="PS"){                               #Create PS map image, convert it to eps file
                     kk=strsplit(display, split="\n")[[1]]
                     orden=paste("export GRASS_WIDTH=",ancho,";export GRASS_HEIGHT=",alto,";export GRASS_RENDER_IMMEDIATE=PS;export GRASS_PSFILE='",output,".ps';export GRASS_TRUECOLOR=TRUE",sep="");
                     if(length(kk)>1){
                           orden=paste(orden,"export GRASS_PS_TRAILER=FALSE","d.erase white",sep=";")
                           orden=paste(orden,"export GRASS_PS_HEADER=FALSE",sep=";")
                           orden=paste(orden,kk[1],sep=";")
                           for (k in 2:(length(kk)-1)){orden=paste(orden,kk[k],sep=";")}
                           orden=paste(orden,"export GRASS_PS_TRAILER=TRUE",sep=";")
                           orden=paste(orden,kk[length(kk)],sep=";")
                     } else {orden=paste(orden,kk[1],sep=";")}
                     system(orden)
                     cat(orden)
                     system(paste("ps2eps -f ",salida,".ps ",salida,".eps",sep=""))
                     imagen=paste(salida,".eps",sep="")
                }
            }
      }

# GMT chunk            
        orden=c()

        # Open postscript file
	#k=1;orden[k]=paste("gmtset D_FORMAT=%7.0f PAPER_MEDIA=",paper," CHAR_ENCODING=UTF8",sep="");system(orden[k])
        k=1;orden[k]=paste("gmtset D_FORMAT=%7.0f PAPER_MEDIA=",paper,sep="");system(orden[k])
        if(gmtset!=""){k=k+1;orden[k]=paste("gmtset",gmtset);system(orden[k])}
	k=k+1;orden[k]=paste("psbasemap ",region," ",escalaGMT," -B::/:: ",port," -X",dxcm,"c -Y",dycm, "c -K>",salida,".ps",sep="");system(orden[k])

        # Draw the map on the postscript file (psimage)
	if(driver=="PNG") draw=paste(salida,".ras",sep="")
    	if(driver=="PS") draw=imagen
        k=k+1;orden[k]=paste("psimage ",draw," -W", anchocm, "c -K -P -O>>", salida, ".ps", sep = "");system(orden[k])
 
        # GMT Vector object (points)
        if (exists(as.character(substitute(points)))){
 		marcado=rep(0,dim(points)[1])
		color=c();w=c();pen=c();icon=c()
		kk=0		
		for (i in 1:dim(points)[1]){
			if (marcado[i]==0) {kk=kk+1;icon[kk]=points[i,4];color[kk]=points[i,5];w[kk]=points[i,6];pen[kk]=points[i,7]}
			for (j in i:dim(points)[1]){
		 	       if (marcado[j]==0){
			            if (points[j,4]==points[i,4] && points[j,5]==points[i,5] && points[j,6]==points[i,6]) marcado[j]=kk
			       }
			}
		}
         
		for (kk in 1:max(marcado)){
		    opc=paste("-",icon[kk]," -G",color[kk]," -W",w[kk],"c/",pen[kk],sep="")
		    k=k+1;orden[k]="echo '";
		    l=0
		    for (i in 1:dim(points)[1]){
		        if(marcado[i]==kk){
		           l=l+1
		           if(l==1){ret=""}else{ret="\n"}
		           orden[k]=paste(orden[k],ret,points[i,1]," ",points[i,2]," ",points[i,3],sep="")
		       }
		    }
	  	    orden[k]=paste(orden[k],"'|psxy -R -J -K -O ",opc,">>",salida,".ps",sep="");system(orden[k])         
               }
        }
        # Text on the mapa (pstext)
        for (i in 1:length(textfile)){
             if(textfile!=""){
                 if(length(textcolor)==1){coltex="-G0/0/0"} else {coltex=sprintf("-G%d/%d/%d",textcolor[i,1],textcolor[i,2],textcolor[i,3])}
                 k=k+1;orden[k]=paste("pstext -R -J ",textfile[i]," ",coltex," -K -O>>",salida,".ps",sep="");system(orden[k])
             }
        }
        # Show  scale Z (psscale)
	if(escalaZ!=""){
                k=k+1;orden[k]=paste("gmtset D_FORMAT=%7.",decscale,"f",sep="");system(orden[k])
                k=k+1;orden[k]=paste("psscale -D",scaleparam," ",scaleoption," -C",escalaZ,".cpt  -O -K>>", salida,".ps",sep="");system(orden[k]) 
                cat(scaleoption)
        	k=k+1;orden[k]="gmtset D_FORMAT=%7.0f";system(orden[k]) 
	}

        # Show legends (pslegend)
        if(leyenda!=""){
             if(gmtsetleg!=""){k=k+1;orden[k]=paste("gmtset ",gmtsetleg,sep="");system(orden[k])}
             for (i in 1:length(leyenda)){
                if(legendpos==""){legendpos=paste(anchocm+3,"c/",altocm,"c/5c/5c",sep="")}  
                k=k+1;orden[k]=paste("pslegend ",leyenda[i],".leg -F ",region," ",escalaGMT," -Dx",legendpos[i],"/TL  -K -O>>",salida,".ps",sep="");system(orden[k]) 
             }
             system("rm .gmtdefaults4")
             if(gmtset!=""){k=k+1;orden[k]=paste("gmtset ",gmtset,sep="");system(orden[k])}
        }

        # Close postscript file
        k=k+1;orden[k]=paste("psbasemap ",region," ",escalaGMT," -Ba",anots,"g",malla,"::WeSn ",port," -O>>", salida, ".ps", sep="");system(orden[k])
	        
        # Convert to pdf
        #system(paste("ps2pdf ",salida,".ps;rm ",salida,".ps",sep=""))
        system(paste("ps2pdf ",salida,".ps",sep=""))
	if(visualizar==T){system(paste("xpdf ",salida,".pdf &",sep=""))}

# Output width and scale
        cat(paste("Width(cm)=",anchocm,"  Scale=1:",sprintf("%g",escala),"\n",sep=""))

# Return GMT script
        output=list();output[[1]]=orden;output[[2]]=escala;output[[3]]=c(anchocm,altocm)
        return(output)
}
