create_palette_v <-
function(map,column,columnRGB="grassrgb",color=c("green","cyan","blue","magenta"),style="quantile",intervals=10,gap=0,title="",columns=1,symbol="s", size=0.5,file="",space1=0.25,space2=0.75,space3=0.25,font="14 Helvetica",decs=2){
 
        fichero=file
        simbolo=symbol
        tam=size
        espacio1=space1
        espacio2=space2
        espacio3=space3 
        titulo=title
        estilo=style

        # Check if columnRGB exists, if not it is created 
        coltype="varchar(11)"
        orden=paste("v.info -c ",map,"|grep ",columnRGB,"|tr '|' ':'",sep="")
        ll=system(orden,intern=T)
        itis=F
        if (length(ll)>0){
            for (i in 1:length(ll)){
               if(strsplit(ll[i],":")[[1]][2]==columnRGB){itis=T}
            }
        }
        if(length(color)>1){ 
            if(!itis){
               orden=paste("v.db.addcol ",map," column='",columnRGB," ",coltype,"'",sep="") 
               system(orden) 
            }

            orden=paste("v.db.select -c ",map," column=",column,sep="")
            samp=as.numeric(system(orden,intern=T))

            ci=classIntervals(samp,intervals,style=estilo)
  	    fc=findColours(classIntervals(samp,intervals,style=estilo),color)
	    val=ci$brks;val[1]=min(samp);val[length(val)]=max(samp)
	    pal= as.numeric(col2rgb(attr(fc,"palette")));dim(pal)=c(3,length(val)-1)

            tabla=strsplit(system(paste("v.db.connect -g ",map,sep=""),intern=T),split=" ")[[1]][2]
            o=paste("echo \"update ",tabla," set ",columnRGB,"='",pal[1,1],":",pal[2,1],":",pal[3,1],"' where ",column,"=",val[1],"\"|db.execute\n",sep="")
            system(o)
            for (j in 2:length(val)){
                o=paste("echo \"update ",tabla," set ",columnRGB,"='",pal[1,j-1],":",pal[2,j-1],":",pal[3,j-1],"' where ",column,">",val[j-1]," and ",column,"<=",val[j],"\"|db.execute\n",sep="")
                system(o)
            }
         }      
        
      
         val=as.integer(val*10^decs)/(10^decs)


        if(fichero!=""){
           system("rm temp.leg")
           if(titulo!=""){
              cat(paste("H ",font," ",titulo,"\n",sep=""),file="temp.leg",append=T) 
              cat("D 0.05c 1p\n",file="temp.leg",append=T)    
           }
           cat(paste("G ",gap,"c\n",sep=""),file="temp.leg",append=T)
           cat(paste("N ",columns,"\n",sep=""),file="temp.leg",append=T)    
           for (j in 1:length(pal[1,])){
              linea=sprintf("S %gc %s %gc %d/%d/%d 0.5p %gc %s - %s\n",espacio1,simbolo,tam, pal[1,j],pal[2,j],pal[3,j],espacio2,val[j],val[j+1]);cat(linea,file="temp.leg",append=T)
              system(paste("iconv -f utf8 -t latin1 temp.leg>",fichero,".leg",sep=""))
           }
        }
}
