vectthematic2leg <-
function(display,gap=0,title="",columns=1,symbol="s",size=0.5,file="",space1=0.25,space2=0.75,space3=0.25,font="14 Helvetica",decs=2){
     titulo=title
     simbolo=symbol
     fichero=file
     espacio1=space1
     espacio2=space2
     espacio3=space3

     system("rm temp.leg")
     if(titulo!=""){
         cat(paste("H ",font," ",titulo,"\n",sep=""),file="temp.leg",append=T) 
         cat("D 0.05c 1p\n",file="temp.leg",append=T)    
     }
     cat(paste("G ",gap,"c\n",sep=""),file="temp.leg",append=T)
     cat(paste("N ",columns,"\n",sep=""),file="temp.leg",append=T)    

     system("d.mon stop=PNG;d.mon PNG")
     kk=system(display,intern=T)
     system("d.mon stop=PNG") 
     k=0
     for (i in 3:length(kk)){
         kkk=strsplit(kk[i],"\t")[[1]]
         rgb=as.integer(strsplit(kkk[1],":")[[1]])
         kkkk=strsplit(kkk[3]," ")[[1]]
         val1=as.integer(as.numeric(kkkk[1])*10^decs)/(10^decs)
         val2=as.integer(as.numeric(kkkk[3])*10^decs)/(10^decs)
         val=paste(val1," - ",val2,sep="")
         k=k+1;if(k>length(simbolo)){k=1};simbol=simbolo[k];tama=size[k];esp1=espacio1[k];esp2=espacio2[k]
         linea=sprintf("S %gc %s %gc %d/%d/%d 0.25p %gc %s\n",esp1,simbol,tama, rgb[1],rgb[2],rgb[3],esp2,val);cat(linea,file="temp.leg",append=T)
      }
      if(fichero!=""){system(paste("iconv -f utf8 -t latin1 temp.leg>",fichero,".leg",sep=""))} 
      else{system("iconv -f utf8 -t latin1 temp.leg>/dev/stdout")} 
}
