\name{create_palette}
\alias{create_palette}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Generates a GRASS palette file for a raster layer with a style determined by the user.
}
\description{
This function uses functions from the package classInt to create color palettes using different styles (see references)
}
\usage{
create_palette(map, color = c("green", "cyan", "blue", "magenta"), 
     style = "quantile", intervals = 10, sample = 1000)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{map}{
GRAS raster map
}
  \item{color}{
A vector of color names to use in the palette
}
  \item{style}{
One of "fixed" "sd" "equal"  "pretty"  "quantile"  "kmeans"  "hclust"  "bclust"  "fisher" or "jenks" 
}
  \item{intervals}{
Number of color intervals in the palette
}
  \item{sample}{
Number of samples taken to calculate statistics
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
}
\references{
  Roger Bivand, with contributions by Hisaji Ono and Richard Dunlap
  (2011). classInt: Choose univariate class intervals. R package
  version 0.1-17. http://CRAN.R-project.org/package=classInt

}
\author{
F. Alonso-Sarria <alonsarp@um.es>
}
\note{
Some of the styles require statistical computation that can be very slow in large raster layers, so there is a need to sample cells.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
