gscale <- 
function(output,dx,dy,di=-1,ni,e,paps=4,type=1){
      if (di==-1){
         GT=gmeta6()
         dm=(GT$e-GT$w)/20
         if(dm<175) ddm=100
         if(dm>=175 && dm<225) dm=200
         if(dm>=225 && dm<375) dm=250
         if(dm>=375 && dm<750) dm=500
         if(dm>=750 && dm<2500) dm=1000
         if(dm>=2500 && dm<7500) dm=5000
         if(dm>=7500 && dm<15000) dm=10000
         di=100*dm/e 
      }else{dm=di; di=100*di/e}
      alto=di*ni/8
 
      if(dm>2000){dm=dm/1000;u="km"}else{u="m"}
      txtl=(nchar(sprintf("%g",dm*ni))+nchar(u))/3

      cat(paste("\\begin{textblock}{",di*(ni+1)+0.5,"}(",dx,",",dy,")\n",sep=""),file=output,append=T)
      cat("\\begin{tikzpicture}\n",file=output,append=T)

      if (type==1){
         cat("\\draw[fill=gray!0] (",-0.25*di,",-0.25) rectangle (",ni*di+txtl,",0.75);\n",file=output,append=T)
         alto=0.25
      }
      if (type<=2){
         for (i in 1:ni){
            if(as.integer(i/2)==(i/2)) {k1=100;k2=0} else{k1=0;k2=100}
            cat("\\draw[fill=gray!",k1,"] (",(i-1)*di,",0) rectangle (",i*di,",",alto,");\n",file=output,append=T)
            cat("\\draw[fill=gray!",k2,"] (",(i-1)*di,",",alto,") rectangle (",i*di,",",2*alto,");\n",file=output,append=T)
         }
         cat("\\end{tikzpicture}\n",file=output,append=T)
         cat("\\end{textblock}\n",file=output,append=T)

         cat(paste("\\begin{textblock}{",di*ni,"}(",dx+(ni+0.5)*di,",",dy+1.5*alto,")\n",sep=""),file=output,append=T)
         if(paps<4 && paps>0){cat(dm*ni," ",u,"\n",file=output,append=T)}
         if(paps==4 || paps==5){cat(dm*ni," ",u,"\n",file=output,append=T)}   
         if(paps>5){cat("{\\tiny ",dm*ni," ",u,"}\n",file=output,append=T)}
         if(paps==-1){cat("{\\tiny ",dm*ni," ",u,"}\n",file=output,append=T)}
      }
      if (type==3){
         cat("\\draw[fill=gray!0] (0,0) rectangle (",ni*di,",0);\n",file=output,append=T)
         cat("\\draw[fill=gray!0] (0,",-alto,") rectangle (0,0);\n",file=output,append=T)
         cat("\\draw[fill=gray!0] (",ni*di,",",-alto,") rectangle (",ni*di,",0);\n",file=output,append=T)
         cat("\\end{tikzpicture}\n",file=output,append=T)
         cat("\\end{textblock}\n",file=output,append=T)
         
         cat(paste("\\begin{textblock}{",di*ni,"}(",dx+0.25*di,",",dy+0.25,")\n",sep=""),file=output,append=T)
         cat("{\\tiny ",dm*ni," ",u,"}\n",file=output,append=T)
      }      
      cat("\\end{textblock}\n",file=output,append=T)
}


