put_palette <- function(map,type,val,red,green,blue){

  # Check if the colr2 directories exist and create them if necessary
      pathpieces=strsplit(colr_grass(map,colr_user=T),"/")[[1]]
      dir1=paste(pathpieces[1:(length(pathpieces)-2)],collapse="/")
      dir2=paste(pathpieces[1:(length(pathpieces)-1)],collapse="/")
      if (!file.exists(dir1)) dir.create(dir1)
      if (!file.exists(dir2)) dir.create(dir2)
  
  # File
      if(length(val)==1){
          write(paste("%",val,val),colr_grass(map,colr_user=T))   
          linea=paste(val,":",red,":",green,":",blue,sep="")
          write(linea,colr_grass(map,colr_user=T),append=T)
      }else{
          minr=min(val);maxr=max(val)
          write(paste("%",minr,maxr),colr_grass(map,colr_user=T))   
          if (type=="c"){
             for (l in 1:(length(val)-1)){     
               linea=paste(val[l],":",red[l],":",green[l],":",blue[l]," ",val[l+1],":",red[l+1],":",green[l+1],":",blue[l+1],sep="")
                 write(linea,colr_grass(map,colr_user=T),append=T) 
             }
          }
          if (type=="d"){
             for (l in 1:length(val)){  
               linea=paste(val[l],":",red[l],":",green[l],":",blue[l],sep="")   
               write(linea,colr_grass(map,colr_user=T),append=T) 
             }
          }

      }
}


            
