rast2leg <-
function(map,gap=0,title="",columns=1,symbol="s",size=0.5,file="",space1=0.25,space2=0.75,space3=0.25,font="14 Helvetica"){

    titulo=title;      fichero=file;    
   

    # Begin legend file
    system("rm temp.leg")
    if(titulo!=""){
       cat(paste("H ",font," ",titulo,"\n",sep=""),file="temp.leg",append=T) 
       cat("D 0.05c 1p\n",file="temp.leg",append=T)    
    }
    cat(paste("G ",gap,"c\n",sep=""),file="temp.leg",append=T)
    cat(paste("N ",columns,"\n",sep=""),file="temp.leg",append=T)    
    # Real cats in the map
    valores=as.numeric(system(paste("r.stats -n ",map,sep=""),intern=T))       
    # Cats in the catfile
    cats=read.csv(catfile_grass(map));cats=cats[1:length(cats[,1]),]
    vale=0
    cate=j1=c()
    for (i in 1:length(cats)){
          if(vale==1){
              fila=strsplit(as.character(cats[i]),":")[[1]]
              j1[i]=as.numeric(fila[1])
              cate[i]=fila[2]                                           
          }
          if (cats[i]=="0.00 0.00 0.00 0.00"){vale=1}
    }
    if (length(cate)==0){cate=j1=valores}
    cate=cate[which(!is.na(j1))]
    j1=j1[which(!is.na(j1))]
    # color codes
    colr=read.csv(colr_grass(map));                                  
    j=r=g=b=c();ii=0
    for (i in 1:(length(colr[,1]))){
       if(substr(as.character(colr[i,]),1,1)!="%") {
          ii=ii+1
          fila=strsplit(as.character(colr[i,])," ")    
          if(length(fila[[1]])==1){
               fila2=strsplit(as.character(fila[[1]][1]),":")
               if(length(fila2[[1]])==4){
                         j[ii]=as.numeric(fila2[[1]][1])
                         r[ii]=as.numeric(fila2[[1]][2])
                         g[ii]=as.numeric(fila2[[1]][3])
                         b[ii]=as.numeric(fila2[[1]][4])
               }
               if(length(fila2[[1]])==2){
                         j[ii]=as.numeric(fila2[[1]][1])
                         r[ii]=as.numeric(fila2[[1]][2])
                         g[ii]=as.numeric(fila2[[1]][2])
                         b[ii]=as.numeric(fila2[[1]][2])
               }

          }else{
               fila2=strsplit(as.character(fila[[1]][1]),":")
               if(length(fila2[[1]])==4){
                         j[ii]=as.numeric(fila2[[1]][1])
                         r[ii]=as.numeric(fila2[[1]][2])
                         g[ii]=as.numeric(fila2[[1]][3])
                         b[ii]=as.numeric(fila2[[1]][4])
               }
               if(length(fila2[[1]])==2){
                         j[ii]=as.numeric(fila2[[1]][1])
                         r[ii]=as.numeric(fila2[[1]][2])
                         g[ii]=as.numeric(fila2[[1]][2])
                         b[ii]=as.numeric(fila2[[1]][2])
               }
          }
        }
     }
     # Last row, second color definition
     if (length(colr[,1])>1 && length(fila)>1){
        i=length(colr[,1])+1
        fila2=strsplit(as.character(fila[[1]][2]),":")
        j[i]=as.numeric(fila2[[1]][1])
        r[i]=as.numeric(fila2[[1]][2])
        g[i]=as.numeric(fila2[[1]][3])
        b[i]=as.numeric(fila2[[1]][4])
    }

     # Mixing and writing to the legend file
     for (i in 1:length(valores)){
           for (h in 1:length(j)){if(j[h]==valores[i]){refr=r[h];refg=g[h];refb=b[h]}}
           for (h in 1:length(cate)){if(j1[h]==valores[i]) {refcat=cate[h]}}
           # prepare & write 
           linea=sprintf("S %gc %s %gc %d/%d/%d 0.5p %gc %s\n",space1,symbol,size, refr,refg,refb,space2, refcat)
           cat(linea,file="temp.leg",append=T)
           if(columns==1){
            cat(paste("G ",space3,"c\n",sep=""),file="temp.leg",append=T) 
           }
     }      
  
     if(fichero!=""){system(paste("iconv -f utf8 -t latin1 temp.leg>",fichero,".leg",sep=""))} 
     else{system("iconv -f utf8 -t latin1 temp.leg>/dev/stdout")} 
}
