vect2leg <-
function(map,column,columnRGB="grassrgb",gap=0,title="",columns=1,symbol="s",size=0.5,file="",space1=0.25,space2=0.75,space3=0.25,font="14 Helvetica",decs=2){

     # Parameters translation
     columna=column;     capa=map;     titulo=title;     fichero=file
     tam=size;     simbolo=symbol;     espacio1=space1;     espacio2=space2
     espacio3=space3
  
     #if(fichero=="") fichero="legend.leg"
     system(paste("rm temp.leg",sep=""))
     if(titulo!=""){
         cat(paste("H ",font," ",titulo,"\n",sep=""),file="temp.leg",append=T) 
         cat("D 0.05c 1p\n",file="temp.leg",append=T)    
     }
     cat(paste("G ",gap,"c\n",sep=""),file="temp.leg",append=T)
     cat(paste("N ",columns,"\n",sep=""),file="temp.leg",append=T)    
       
     cols=paste(columna,",",columnRGB,sep="")
     val=query_grass(capa,cols,distinct=T)

     k=0
     for (i in 1:length(val[,1])){
         k=k+1
         if(k>length(simbolo)){k=1};simbol=simbolo[k];tama=tam[k];esp1=espacio1[k];esp2=espacio2[k]
         rgb1=strsplit(sprintf("%s",val[i,2]),":")[[1]]
         if(length(rgb1)==3){
             rgb=as.numeric(rgb1)
             linea=sprintf("S %gc %s %gc %d/%d/%d 0.25p %gc %s\n",esp1,simbol,tama, rgb[1],rgb[2],rgb[3],esp2,val[i,1]);cat(linea,file="temp.leg",append=T)
         }
     }
     if(fichero!=""){system(paste("iconv -f utf8 -t latin1 temp.leg>",fichero,".leg",sep=""))} 
     else{system("iconv -f utf8 -t latin1 temp.leg>/dev/stdout")} 
}
