\name{grasspoints2GMTtext}
\alias{grasspoints2GMTtext}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Transforms labels from a GRASS vector layer in a GMT labels file.
}
\description{
This function reads the values of a column in the table linked to a GRASS vector map and uses them to create a  GMT labels file. It can use points or centroids.

The label positions on the final map will depend on the location of centroids or points in the original map- They can be changed by manually editing the labels file or by editing the map with v.digit.
}
\usage{
grasspoints2GMTtext(map,size=12,angle=0,font=1,just="MC",column,file,distinct=F)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{map}{
GRASS vector map
}
  \item{size}{
Label text size
}
  \item{angle}{
Angle of the lables
}
  \item{font}{
Font fot the labels
}
  \item{just}{
Justification code, it is formed by two characters: "T" (top), "M" (middle) or "B" (bottom) and "L" (left), "C" (center) or "R" (right)
}
  \item{column}{
column that contains the labels
}
  \item{file}{
Output GMT labels file
}
  \item{distinct}{
Determines if repeated labels should be displayed just once (distinct=T) or not (distinct=F)
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
}
\references{
%% ~put references to the literature/web site here ~
}
\author{
Francisco Alonso-Sarria <alonsarp@um.es>
}
\note{
It can be difficult to obtain an adequate distribution of text labels. If dealing with centroids, a good option is to edit their position with v.digit. If it is not possible a posterior, edition of the text file created can be achieved.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
